package com.scbfkj.uni.process;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.scbfkj.uni.library.DataFormatUtil;
import org.junit.jupiter.api.Test;
import org.springframework.boot.test.context.SpringBootTest;

import java.util.*;

import static org.junit.jupiter.api.Assertions.*;

@SpringBootTest
class DataBaseTest {
    static String connectionStr = """
                            {
              "jdbcUrl": "jdbc:mysql://120.26.64.82:3306/mid_log",
              "username": "root",
              "password": "123@bigdata",
              "driverClassName": "com.mysql.cj.jdbc.Driver"
            }""";
    public static String tableName = "log_error";

  static    List<Map<String, Object>> insert = Collections.singletonList(new HashMap<>() {{
        put("filter", new HashMap<>() {{
            put("id", 15);
        }});
        put("value", new HashMap<>() {{
            put("id", 15);
        }});
    }});

    static List<Map<String, Object>> update = Collections.singletonList(new HashMap<>() {{
        put("filter", new HashMap<>() {{
            put("id", 15);
        }});
        put("value", new HashMap<>() {{
            put("serviceid", 999);
            put("id", 15);
        }});
    }});

  static   List<Map<String, Object>> insertOrupdate = new ArrayList<>() {{
        add(new HashMap<>() {{
            put("filter", new HashMap<>() {{
                put("id", 15);
            }});
            put("value", new HashMap<>() {{
                put("serviceid", 1000);
                put("id", 15);
            }});
        }});
        add(new HashMap<>() {{
            put("filter", new HashMap<>() {{
                put("id", 16);
            }});
            put("value", new HashMap<>() {{
                put("serviceid", 1000);
                put("id", 16);
            }});
        }});
    }};
   static List<String> filterColumns = new ArrayList<>() {{
        add("id");
        add("serviceid");
    }};
   static HashMap<String, Object> filterLines = new HashMap<>() {{
        put("id", 15);
    }};

    @Test
    void exec() throws Exception {



        Map<String, Object> exec = DataBase.exec(connectionStr, tableName, insert, "3", filterColumns, filterLines);
        System.out.println(DataFormatUtil.toString(exec));
        exec = DataBase.exec(connectionStr, tableName, insert, "1", filterColumns, filterLines);
        System.out.println(DataFormatUtil.toString(exec));
        exec = DataBase.exec(connectionStr, tableName, insert, "0", filterColumns, filterLines);
        System.out.println(DataFormatUtil.toString(exec));
        exec = DataBase.exec(connectionStr, tableName, update, "2", filterColumns, filterLines);
        System.out.println(DataFormatUtil.toString(exec));
        exec = DataBase.exec(connectionStr, tableName, update, "0", filterColumns, filterLines);
        System.out.println(DataFormatUtil.toString(exec));
        exec = DataBase.exec(connectionStr, tableName, insertOrupdate, "6", filterColumns, filterLines);
        System.out.println(DataFormatUtil.toString(exec));
        exec = DataBase.exec(connectionStr, tableName, insertOrupdate, "0", filterColumns, filterLines);
        System.out.println(DataFormatUtil.toString(exec));
    }

    @Test
    public void test() throws Exception {
        Map<String, Object> exec = DataBase.exec(connectionStr, "select * from %s where 《whereStr》".formatted(tableName), insert, "0", filterColumns, filterLines);
        System.out.println(DataFormatUtil.toString(exec));
    }
}